/* ***********************************************************
 * This file was automatically generated on 2019-09-23.      *
 *                                                           *
 * OpenHAB Bindings Version 2.1.23                           *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;
import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.function.Function;
import java.util.function.BiConsumer;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.thing.CommonTriggerEvents;
import org.eclipse.smarthome.core.library.types.StringType;
import org.eclipse.smarthome.core.library.types.PointType;
import org.eclipse.smarthome.core.library.types.DateTimeType;
import org.eclipse.smarthome.core.library.types.DecimalType;
import org.eclipse.smarthome.core.library.types.OnOffType;
import java.time.ZoneId;

/**
 * Determine position, velocity and altitude using GPS
 */
public class BrickletGPS extends Device {
	public final static int DEVICE_IDENTIFIER = 222;
	public final static String DEVICE_DISPLAY_NAME = "GPS Bricklet";

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(DEVICE_DISPLAY_NAME, "gps", DEVICE_IDENTIFIER, BrickletGPS.class);

	public final static byte FUNCTION_GET_COORDINATES = (byte)1;
	public final static byte FUNCTION_GET_STATUS = (byte)2;
	public final static byte FUNCTION_GET_ALTITUDE = (byte)3;
	public final static byte FUNCTION_GET_MOTION = (byte)4;
	public final static byte FUNCTION_GET_DATE_TIME = (byte)5;
	public final static byte FUNCTION_RESTART = (byte)6;
	public final static byte FUNCTION_SET_COORDINATES_CALLBACK_PERIOD = (byte)7;
	public final static byte FUNCTION_GET_COORDINATES_CALLBACK_PERIOD = (byte)8;
	public final static byte FUNCTION_SET_STATUS_CALLBACK_PERIOD = (byte)9;
	public final static byte FUNCTION_GET_STATUS_CALLBACK_PERIOD = (byte)10;
	public final static byte FUNCTION_SET_ALTITUDE_CALLBACK_PERIOD = (byte)11;
	public final static byte FUNCTION_GET_ALTITUDE_CALLBACK_PERIOD = (byte)12;
	public final static byte FUNCTION_SET_MOTION_CALLBACK_PERIOD = (byte)13;
	public final static byte FUNCTION_GET_MOTION_CALLBACK_PERIOD = (byte)14;
	public final static byte FUNCTION_SET_DATE_TIME_CALLBACK_PERIOD = (byte)15;
	public final static byte FUNCTION_GET_DATE_TIME_CALLBACK_PERIOD = (byte)16;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_COORDINATES = 17;
	private final static int CALLBACK_STATUS = 18;
	private final static int CALLBACK_ALTITUDE = 19;
	private final static int CALLBACK_MOTION = 20;
	private final static int CALLBACK_DATE_TIME = 21;

	public final static short FIX_NO_FIX = (short)1;
	public final static short FIX_2D_FIX = (short)2;
	public final static short FIX_3D_FIX = (short)3;
	public final static short RESTART_TYPE_HOT_START = (short)0;
	public final static short RESTART_TYPE_WARM_START = (short)1;
	public final static short RESTART_TYPE_COLD_START = (short)2;
	public final static short RESTART_TYPE_FACTORY_RESET = (short)3;

	private List<CoordinatesListener> listenerCoordinates = new CopyOnWriteArrayList<CoordinatesListener>();
	private List<StatusListener> listenerStatus = new CopyOnWriteArrayList<StatusListener>();
	private List<AltitudeListener> listenerAltitude = new CopyOnWriteArrayList<AltitudeListener>();
	private List<MotionListener> listenerMotion = new CopyOnWriteArrayList<MotionListener>();
	private List<DateTimeListener> listenerDateTime = new CopyOnWriteArrayList<DateTimeListener>();

	public class Coordinates {
		public long latitude;
		public char ns;
		public long longitude;
		public char ew;
		public int pdop;
		public int hdop;
		public int vdop;
		public int epe;

		public String toString() {
			return "[" + "latitude = " + latitude + ", " + "ns = " + ns + ", " + "longitude = " + longitude + ", " + "ew = " + ew + ", " + "pdop = " + pdop + ", " + "hdop = " + hdop + ", " + "vdop = " + vdop + ", " + "epe = " + epe + "]";
		}
	}

	public class Status {
		public short fix;
		public short satellitesView;
		public short satellitesUsed;

		public String toString() {
			return "[" + "fix = " + fix + ", " + "satellitesView = " + satellitesView + ", " + "satellitesUsed = " + satellitesUsed + "]";
		}
	}

	public class Altitude {
		public int altitude;
		public int geoidalSeparation;

		public String toString() {
			return "[" + "altitude = " + altitude + ", " + "geoidalSeparation = " + geoidalSeparation + "]";
		}
	}

	public class Motion {
		public long course;
		public long speed;

		public String toString() {
			return "[" + "course = " + course + ", " + "speed = " + speed + "]";
		}
	}

	public class DateTime {
		public long date;
		public long time;

		public String toString() {
			return "[" + "date = " + date + ", " + "time = " + time + "]";
		}
	}

	/**
	 * This listener is triggered periodically with the period that is set by
	 * {@link BrickletGPS#setCoordinatesCallbackPeriod(long)}. The parameters are the same
	 * as for {@link BrickletGPS#getCoordinates()}.
	 * 
	 * The {@link BrickletGPS.CoordinatesListener} listener is only triggered if the coordinates changed
	 * since the last triggering and if there is currently a fix as indicated by
	 * {@link BrickletGPS#getStatus()}.
	 */
	public interface CoordinatesListener extends DeviceListener {
		public void coordinates(long latitude, char ns, long longitude, char ew, int pdop, int hdop, int vdop, int epe);
	}

	/**
	 * This listener is triggered periodically with the period that is set by
	 * {@link BrickletGPS#setStatusCallbackPeriod(long)}. The parameters are the same
	 * as for {@link BrickletGPS#getStatus()}.
	 * 
	 * The {@link BrickletGPS.StatusListener} listener is only triggered if the status changed since the
	 * last triggering.
	 */
	public interface StatusListener extends DeviceListener {
		public void status(short fix, short satellitesView, short satellitesUsed);
	}

	/**
	 * This listener is triggered periodically with the period that is set by
	 * {@link BrickletGPS#setAltitudeCallbackPeriod(long)}. The parameters are the same
	 * as for {@link BrickletGPS#getAltitude()}.
	 * 
	 * The {@link BrickletGPS.AltitudeListener} listener is only triggered if the altitude changed since
	 * the last triggering and if there is currently a fix as indicated by
	 * {@link BrickletGPS#getStatus()}.
	 */
	public interface AltitudeListener extends DeviceListener {
		public void altitude(int altitude, int geoidalSeparation);
	}

	/**
	 * This listener is triggered periodically with the period that is set by
	 * {@link BrickletGPS#setMotionCallbackPeriod(long)}. The parameters are the same
	 * as for {@link BrickletGPS#getMotion()}.
	 * 
	 * The {@link BrickletGPS.MotionListener} listener is only triggered if the motion changed since the
	 * last triggering and if there is currently a fix as indicated by
	 * {@link BrickletGPS#getStatus()}.
	 */
	public interface MotionListener extends DeviceListener {
		public void motion(long course, long speed);
	}

	/**
	 * This listener is triggered periodically with the period that is set by
	 * {@link BrickletGPS#setDateTimeCallbackPeriod(long)}. The parameters are the same
	 * as for {@link BrickletGPS#getDateTime()}.
	 * 
	 * The {@link BrickletGPS.DateTimeListener} listener is only triggered if the date or time changed
	 * since the last triggering.
	 */
	public interface DateTimeListener extends DeviceListener {
		public void dateTime(long date, long time);
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletGPS(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 1;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_COORDINATES)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_STATUS)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_ALTITUDE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_MOTION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_DATE_TIME)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_RESTART)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_COORDINATES_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_COORDINATES_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_STATUS_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_STATUS_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_ALTITUDE_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_ALTITUDE_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_MOTION_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_MOTION_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_DATE_TIME_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_DATE_TIME_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_COORDINATES] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				long latitude = IPConnection.unsignedInt(bb.getInt());
				char ns = (char)(bb.get());
				long longitude = IPConnection.unsignedInt(bb.getInt());
				char ew = (char)(bb.get());
				int pdop = IPConnection.unsignedShort(bb.getShort());
				int hdop = IPConnection.unsignedShort(bb.getShort());
				int vdop = IPConnection.unsignedShort(bb.getShort());
				int epe = IPConnection.unsignedShort(bb.getShort());

				for (CoordinatesListener listener: listenerCoordinates) {
					listener.coordinates(latitude, ns, longitude, ew, pdop, hdop, vdop, epe);
				}
			}
		};

		callbacks[CALLBACK_STATUS] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				short fix = IPConnection.unsignedByte(bb.get());
				short satellitesView = IPConnection.unsignedByte(bb.get());
				short satellitesUsed = IPConnection.unsignedByte(bb.get());

				for (StatusListener listener: listenerStatus) {
					listener.status(fix, satellitesView, satellitesUsed);
				}
			}
		};

		callbacks[CALLBACK_ALTITUDE] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int altitude = (bb.getInt());
				int geoidalSeparation = (bb.getInt());

				for (AltitudeListener listener: listenerAltitude) {
					listener.altitude(altitude, geoidalSeparation);
				}
			}
		};

		callbacks[CALLBACK_MOTION] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				long course = IPConnection.unsignedInt(bb.getInt());
				long speed = IPConnection.unsignedInt(bb.getInt());

				for (MotionListener listener: listenerMotion) {
					listener.motion(course, speed);
				}
			}
		};

		callbacks[CALLBACK_DATE_TIME] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				long date = IPConnection.unsignedInt(bb.getInt());
				long time = IPConnection.unsignedInt(bb.getInt());

				for (DateTimeListener listener: listenerDateTime) {
					listener.dateTime(date, time);
				}
			}
		};
	}

	/**
	 * Returns the GPS coordinates. Latitude and longitude are given in the
	 * ``DD.dddddd°`` format, the value 57123468 means 57.123468°.
	 * The parameter ``ns`` and ``ew`` are the cardinal directions for
	 * latitude and longitude. Possible values for ``ns`` and ``ew`` are 'N', 'S', 'E'
	 * and 'W' (north, south, east and west).
	 * 
	 * PDOP, HDOP and VDOP are the dilution of precision (DOP) values. They specify
	 * the additional multiplicative effect of GPS satellite geometry on GPS
	 * precision. See
	 * `here &lt;https://en.wikipedia.org/wiki/Dilution_of_precision_(GPS)&gt;`__
	 * for more information. The values are give in hundredths.
	 * 
	 * EPE is the "Estimated Position Error". The EPE is given in cm. This is not the
	 * absolute maximum error, it is the error with a specific confidence. See
	 * `here &lt;https://www.nps.gov/gis/gps/WhatisEPE.html&gt;`__ for more information.
	 * 
	 * This data is only valid if there is currently a fix as indicated by
	 * {@link BrickletGPS#getStatus()}.
	 */
	public Coordinates getCoordinates() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_COORDINATES, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Coordinates obj = new Coordinates();
		obj.latitude = IPConnection.unsignedInt(bb.getInt());
		obj.ns = (char)(bb.get());
		obj.longitude = IPConnection.unsignedInt(bb.getInt());
		obj.ew = (char)(bb.get());
		obj.pdop = IPConnection.unsignedShort(bb.getShort());
		obj.hdop = IPConnection.unsignedShort(bb.getShort());
		obj.vdop = IPConnection.unsignedShort(bb.getShort());
		obj.epe = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Returns the current fix status, the number of satellites that are in view and
	 * the number of satellites that are currently used.
	 * 
	 * Possible fix status values can be:
	 * 
	 * \verbatim
	 *  "Value", "Description"
	 * 
	 *  "1", "No Fix, {@link BrickletGPS#getCoordinates()}, {@link BrickletGPS#getAltitude()} and {@link BrickletGPS#getMotion()} return invalid data"
	 *  "2", "2D Fix, only {@link BrickletGPS#getCoordinates()} and {@link BrickletGPS#getMotion()} return valid data"
	 *  "3", "3D Fix, {@link BrickletGPS#getCoordinates()}, {@link BrickletGPS#getAltitude()} and {@link BrickletGPS#getMotion()} return valid data"
	 * \endverbatim
	 * 
	 * There is also a :ref:`blue LED &lt;gps_bricklet_fix_led&gt;` on the Bricklet that
	 * indicates the fix status.
	 */
	public Status getStatus() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_STATUS, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Status obj = new Status();
		obj.fix = IPConnection.unsignedByte(bb.get());
		obj.satellitesView = IPConnection.unsignedByte(bb.get());
		obj.satellitesUsed = IPConnection.unsignedByte(bb.get());

		return obj;
	}

	/**
	 * Returns the current altitude and corresponding geoidal separation.
	 * 
	 * Both values are given in cm.
	 * 
	 * This data is only valid if there is currently a fix as indicated by
	 * {@link BrickletGPS#getStatus()}.
	 */
	public Altitude getAltitude() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_ALTITUDE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Altitude obj = new Altitude();
		obj.altitude = (bb.getInt());
		obj.geoidalSeparation = (bb.getInt());

		return obj;
	}

	/**
	 * Returns the current course and speed. Course is given in hundredths degree
	 * and speed is given in hundredths km/h. A course of 0° means the Bricklet is
	 * traveling north bound and 90° means it is traveling east bound.
	 * 
	 * Please note that this only returns useful values if an actual movement
	 * is present.
	 * 
	 * This data is only valid if there is currently a fix as indicated by
	 * {@link BrickletGPS#getStatus()}.
	 */
	public Motion getMotion() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_MOTION, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Motion obj = new Motion();
		obj.course = IPConnection.unsignedInt(bb.getInt());
		obj.speed = IPConnection.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Returns the current date and time. The date is
	 * given in the format ``ddmmyy`` and the time is given
	 * in the format ``hhmmss.sss``. For example, 140713 means
	 * 14.07.13 as date and 195923568 means 19:59:23.568 as time.
	 */
	public DateTime getDateTime() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_DATE_TIME, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		DateTime obj = new DateTime();
		obj.date = IPConnection.unsignedInt(bb.getInt());
		obj.time = IPConnection.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Restarts the GPS Bricklet, the following restart types are available:
	 * 
	 * \verbatim
	 *  "Value", "Description"
	 * 
	 *  "0", "Hot start (use all available data in the NV store)"
	 *  "1", "Warm start (don't use ephemeris at restart)"
	 *  "2", "Cold start (don't use time, position, almanacs and ephemeris at restart)"
	 *  "3", "Factory reset (clear all system/user configurations at restart)"
	 * \endverbatim
	 */
	public void restart(short restartType) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_RESTART, this);

		bb.put((byte)restartType);

		sendRequest(bb.array());
	}

	/**
	 * Sets the period in ms with which the {@link BrickletGPS.CoordinatesListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 * 
	 * The {@link BrickletGPS.CoordinatesListener} listener is only triggered if the coordinates changed
	 * since the last triggering.
	 * 
	 * The default value is 0.
	 */
	public void setCoordinatesCallbackPeriod(long period) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_COORDINATES_CALLBACK_PERIOD, this);

		bb.putInt((int)period);

		sendRequest(bb.array());
	}

	/**
	 * Returns the period as set by {@link BrickletGPS#setCoordinatesCallbackPeriod(long)}.
	 */
	public long getCoordinatesCallbackPeriod() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_COORDINATES_CALLBACK_PERIOD, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnection.unsignedInt(bb.getInt());

		return period;
	}

	/**
	 * Sets the period in ms with which the {@link BrickletGPS.StatusListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 * 
	 * The {@link BrickletGPS.StatusListener} listener is only triggered if the status changed since the
	 * last triggering.
	 * 
	 * The default value is 0.
	 */
	public void setStatusCallbackPeriod(long period) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_STATUS_CALLBACK_PERIOD, this);

		bb.putInt((int)period);

		sendRequest(bb.array());
	}

	/**
	 * Returns the period as set by {@link BrickletGPS#setStatusCallbackPeriod(long)}.
	 */
	public long getStatusCallbackPeriod() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_STATUS_CALLBACK_PERIOD, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnection.unsignedInt(bb.getInt());

		return period;
	}

	/**
	 * Sets the period in ms with which the {@link BrickletGPS.AltitudeListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 * 
	 * The {@link BrickletGPS.AltitudeListener} listener is only triggered if the altitude changed since
	 * the last triggering.
	 * 
	 * The default value is 0.
	 */
	public void setAltitudeCallbackPeriod(long period) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_ALTITUDE_CALLBACK_PERIOD, this);

		bb.putInt((int)period);

		sendRequest(bb.array());
	}

	/**
	 * Returns the period as set by {@link BrickletGPS#setAltitudeCallbackPeriod(long)}.
	 */
	public long getAltitudeCallbackPeriod() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_ALTITUDE_CALLBACK_PERIOD, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnection.unsignedInt(bb.getInt());

		return period;
	}

	/**
	 * Sets the period in ms with which the {@link BrickletGPS.MotionListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 * 
	 * The {@link BrickletGPS.MotionListener} listener is only triggered if the motion changed since the
	 * last triggering.
	 * 
	 * The default value is 0.
	 */
	public void setMotionCallbackPeriod(long period) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_MOTION_CALLBACK_PERIOD, this);

		bb.putInt((int)period);

		sendRequest(bb.array());
	}

	/**
	 * Returns the period as set by {@link BrickletGPS#setMotionCallbackPeriod(long)}.
	 */
	public long getMotionCallbackPeriod() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_MOTION_CALLBACK_PERIOD, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnection.unsignedInt(bb.getInt());

		return period;
	}

	/**
	 * Sets the period in ms with which the {@link BrickletGPS.DateTimeListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 * 
	 * The {@link BrickletGPS.DateTimeListener} listener is only triggered if the date or time changed
	 * since the last triggering.
	 * 
	 * The default value is 0.
	 */
	public void setDateTimeCallbackPeriod(long period) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_DATE_TIME_CALLBACK_PERIOD, this);

		bb.putInt((int)period);

		sendRequest(bb.array());
	}

	/**
	 * Returns the period as set by {@link BrickletGPS#setDateTimeCallbackPeriod(long)}.
	 */
	public long getDateTimeCallbackPeriod() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_DATE_TIME_CALLBACK_PERIOD, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnection.unsignedInt(bb.getInt());

		return period;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c' or 'd'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnection.string(bb, 8);
		obj.connectedUid = IPConnection.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Adds a Coordinates listener.
	 */
	public void addCoordinatesListener(CoordinatesListener listener) {
		listenerCoordinates.add(listener);
	}

	/**
	 * Removes a Coordinates listener.
	 */
	public void removeCoordinatesListener(CoordinatesListener listener) {
		listenerCoordinates.remove(listener);
	}

	/**
	 * Adds a Status listener.
	 */
	public void addStatusListener(StatusListener listener) {
		listenerStatus.add(listener);
	}

	/**
	 * Removes a Status listener.
	 */
	public void removeStatusListener(StatusListener listener) {
		listenerStatus.remove(listener);
	}

	/**
	 * Adds a Altitude listener.
	 */
	public void addAltitudeListener(AltitudeListener listener) {
		listenerAltitude.add(listener);
	}

	/**
	 * Removes a Altitude listener.
	 */
	public void removeAltitudeListener(AltitudeListener listener) {
		listenerAltitude.remove(listener);
	}

	/**
	 * Adds a Motion listener.
	 */
	public void addMotionListener(MotionListener listener) {
		listenerMotion.add(listener);
	}

	/**
	 * Removes a Motion listener.
	 */
	public void removeMotionListener(MotionListener listener) {
		listenerMotion.remove(listener);
	}

	/**
	 * Adds a DateTime listener.
	 */
	public void addDateTimeListener(DateTimeListener listener) {
		listenerDateTime.add(listener);
	}

	/**
	 * Removes a DateTime listener.
	 */
	public void removeDateTimeListener(DateTimeListener listener) {
		listenerDateTime.remove(listener);
	}

    private final Logger logger = LoggerFactory.getLogger(BrickletGPS.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletGPS.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletGPSConfig cfg = (BrickletGPSConfig) config.as(BrickletGPSConfig.class);
        this.addCoordinatesListener((latitude, ns, longitude, ew, pdop, hdop, vdop, epe) -> {if(true) {updateStateFn.accept("GPSLocation", transformGPSLocationCallback0(latitude, ns, longitude, ew, pdop, hdop, vdop, epe, cfg));}});
		this.addStatusListener((fix, satellitesView, satellitesUsed) -> {if(true) {updateStateFn.accept("GPSFix", transformGPSFixCallback0(fix, satellitesView, satellitesUsed, cfg));}});
		this.addStatusListener((fix, satellitesView, satellitesUsed) -> {if(true) {updateStateFn.accept("GPSSatellitesInView", transformGPSSatellitesInViewCallback0(fix, satellitesView, satellitesUsed, cfg));}});
		this.addStatusListener((fix, satellitesView, satellitesUsed) -> {if(true) {updateStateFn.accept("GPSSatellitesUsed", transformGPSSatellitesUsedCallback0(fix, satellitesView, satellitesUsed, cfg));}});
		this.addAltitudeListener((altitude, geoidalSeparation) -> {if(true) {updateStateFn.accept("GPSAltitude", transformGPSAltitudeCallback0(altitude, geoidalSeparation, cfg));}});
		this.addAltitudeListener((altitude, geoidalSeparation) -> {if(true) {updateStateFn.accept("GPSGeoidalSeparation", transformGPSGeoidalSeparationCallback0(altitude, geoidalSeparation, cfg));}});
		this.addMotionListener((course, speed) -> {if(true) {updateStateFn.accept("GPSCourse", transformGPSCourseCallback0(course, speed, cfg));}});
		this.addMotionListener((course, speed) -> {if(true) {updateStateFn.accept("GPSSpeed", transformGPSSpeedCallback0(course, speed, cfg));}});
		this.addDateTimeListener((date, time) -> {if(true) {updateStateFn.accept("GPSDateTime", transformGPSDateTimeCallback0(date, time, cfg));}});
        
		{
		BrickletGPSLocationConfig channelCfg = getChannelConfigFn.apply("GPSLocation").as(BrickletGPSLocationConfig.class);
		this.setCoordinatesCallbackPeriod(channelCfg.updateInterval);
		}
		{
		BrickletGPSFixConfig channelCfg = getChannelConfigFn.apply("GPSFix").as(BrickletGPSFixConfig.class);
		this.setStatusCallbackPeriod(channelCfg.updateInterval);
		}
		{
		BrickletGPSSatellitesInViewConfig channelCfg = getChannelConfigFn.apply("GPSSatellitesInView").as(BrickletGPSSatellitesInViewConfig.class);
		
		}
		{
		BrickletGPSSatellitesUsedConfig channelCfg = getChannelConfigFn.apply("GPSSatellitesUsed").as(BrickletGPSSatellitesUsedConfig.class);
		
		}
		{
		BrickletGPSAltitudeConfig channelCfg = getChannelConfigFn.apply("GPSAltitude").as(BrickletGPSAltitudeConfig.class);
		this.setAltitudeCallbackPeriod(channelCfg.updateInterval);
		}
		{
		BrickletGPSGeoidalSeparationConfig channelCfg = getChannelConfigFn.apply("GPSGeoidalSeparation").as(BrickletGPSGeoidalSeparationConfig.class);
		
		}
		{
		BrickletGPSCourseConfig channelCfg = getChannelConfigFn.apply("GPSCourse").as(BrickletGPSCourseConfig.class);
		this.setMotionCallbackPeriod(channelCfg.updateInterval);
		}
		{
		BrickletGPSSpeedConfig channelCfg = getChannelConfigFn.apply("GPSSpeed").as(BrickletGPSSpeedConfig.class);
		
		}
		{
		BrickletGPSDateTimeConfig channelCfg = getChannelConfigFn.apply("GPSDateTime").as(BrickletGPSDateTimeConfig.class);
		this.setDateTimeCallbackPeriod(channelCfg.updateInterval);
		}
		{
		BrickletGPSRestartConfig channelCfg = getChannelConfigFn.apply("GPSRestart").as(BrickletGPSRestartConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        BrickletGPSConfig cfg = (BrickletGPSConfig) config.as(BrickletGPSConfig.class);
        this.listenerCoordinates.clear();
		this.listenerStatus.clear();
		this.listenerStatus.clear();
		this.listenerStatus.clear();
		this.listenerAltitude.clear();
		this.listenerAltitude.clear();
		this.listenerMotion.clear();
		this.listenerMotion.clear();
		this.listenerDateTime.clear();
        this.setCoordinatesCallbackPeriod(0);
		this.setStatusCallbackPeriod(0);
		
		
		this.setAltitudeCallbackPeriod(0);
		
		this.setMotionCallbackPeriod(0);
		
		this.setDateTimeCallbackPeriod(0);
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletGPSConfig cfg = (BrickletGPSConfig) config.as(BrickletGPSConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("GPSLocation");
		result.add("GPSFix");
		result.add("GPSSatellitesInView");
		result.add("GPSSatellitesUsed");
		result.add("GPSAltitude");
		result.add("GPSGeoidalSeparation");
		result.add("GPSCourse");
		result.add("GPSSpeed");
		result.add("GPSDateTime");
		result.add("GPSRestart");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "GPSLocation":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "GPSLocation"), "Location", "Location").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:GPSLocation")).withDescription("The location as determined by the bricklet.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            case "GPSFix":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "GPSFix"), "Fix", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:GPSFix")).withDescription("If enabled, a fix is currently available")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            case "GPSSatellitesInView":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "GPSSatellitesInView"), "Satellites In View", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:GPSSatellitesInView")).withDescription("The number of satellites that are in view.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%d %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "GPSSatellitesUsed":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "GPSSatellitesUsed"), "Satellites Used", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:GPSSatellitesUsed")).withDescription("The number of satellites that are currently used.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%d %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "GPSAltitude":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "GPSAltitude"), "Altitude", "Number:Length").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:GPSAltitude")).withDescription("The current altitude")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%.2f %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "GPSGeoidalSeparation":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "GPSGeoidalSeparation"), "Geoidal Separation", "Number:Length").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:GPSGeoidalSeparation")).withDescription("The geoidal separation corresponding to the current altitude")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%.2f %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "GPSCourse":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "GPSCourse"), "Course", "Number:Angle").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:GPSCourse")).withDescription("The current course. A course of 0° means the Bricklet is traveling north bound and 90° means it is traveling east bound. Please note that this only returns useful values if an actual movement is present.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%.2f %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "GPSSpeed":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "GPSSpeed"), "Speed", "Number:Speed").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:GPSSpeed")).withDescription("The current speed. Please note that this only returns useful values if an actual movement is present.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%.2f").withReadOnly(true).build().toStateDescription()).build();
            case "GPSDateTime":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "GPSDateTime"), "Date Time", "DateTime").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:GPSDateTime")).withDescription("The current date and time.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            case "GPSRestart":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "GPSRestart"), "Restart", "String").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:GPSRestart")).withDescription("Restarts the GPS Bricklet, the following restart types are available:<ul><li>Hot start (use all available data in the NV store)</li> <li>Warm start (don't use ephemeris at restart)</li> <li>Cold start (don't use time, position, almanacs and ephemeris at restart)</li> <li>Factory reset (clear all system/user configurations at restart)</li></ul>")
.withCommandDescription(CommandDescriptionBuilder.create().withCommandOption(new CommandOption("0", "Hot Start")).withCommandOption(new CommandOption("1", "Warm Start")).withCommandOption(new CommandOption("2", "Cold Start")).withCommandOption(new CommandOption("3", "Factory reset")).build()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge GPS Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.getId())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Determine position, velocity and altitude using GPS").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("GPSLocation", new ChannelTypeUID("tinkerforge", "GPSLocation")).build(), new ChannelDefinitionBuilder("GPSFix", new ChannelTypeUID("tinkerforge", "GPSFix")).build(), new ChannelDefinitionBuilder("GPSSatellitesInView", new ChannelTypeUID("tinkerforge", "GPSSatellitesInView")).build(), new ChannelDefinitionBuilder("GPSSatellitesUsed", new ChannelTypeUID("tinkerforge", "GPSSatellitesUsed")).build(), new ChannelDefinitionBuilder("GPSAltitude", new ChannelTypeUID("tinkerforge", "GPSAltitude")).build(), new ChannelDefinitionBuilder("GPSGeoidalSeparation", new ChannelTypeUID("tinkerforge", "GPSGeoidalSeparation")).build(), new ChannelDefinitionBuilder("GPSCourse", new ChannelTypeUID("tinkerforge", "GPSCourse")).build(), new ChannelDefinitionBuilder("GPSSpeed", new ChannelTypeUID("tinkerforge", "GPSSpeed")).build(), new ChannelDefinitionBuilder("GPSDateTime", new ChannelTypeUID("tinkerforge", "GPSDateTime")).build(), new ChannelDefinitionBuilder("GPSRestart", new ChannelTypeUID("tinkerforge", "GPSRestart")).build())).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:gps":
                return new ConfigDescription(uri, Arrays.asList(), Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals")));
            case "channel-type:tinkerforge:GPSLocation":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build()));
            case "channel-type:tinkerforge:GPSFix":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build()));
            case "channel-type:tinkerforge:GPSSatellitesInView":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build()));
            case "channel-type:tinkerforge:GPSSatellitesUsed":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build()));
            case "channel-type:tinkerforge:GPSAltitude":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build()));
            case "channel-type:tinkerforge:GPSGeoidalSeparation":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build()));
            case "channel-type:tinkerforge:GPSCourse":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build()));
            case "channel-type:tinkerforge:GPSSpeed":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build()));
            case "channel-type:tinkerforge:GPSDateTime":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build()));
            case "channel-type:tinkerforge:GPSRestart":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build()));
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String value, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletGPSConfig cfg = (BrickletGPSConfig) config.as(BrickletGPSConfig.class);
        switch(value) {
            case "GPSLocation":
               return;
            case "GPSFix": {
                   BrickletGPSFixConfig channelCfg = channelConfig.as(BrickletGPSFixConfig.class);
                   updateStateFn.accept(value, transformGPSFixGetter0(this.getStatus(), cfg));
                   return;
               }
            case "GPSSatellitesInView": {
                   BrickletGPSSatellitesInViewConfig channelCfg = channelConfig.as(BrickletGPSSatellitesInViewConfig.class);
                   updateStateFn.accept(value, transformGPSSatellitesInViewGetter0(this.getStatus(), cfg));
                   return;
               }
            case "GPSSatellitesUsed": {
                   BrickletGPSSatellitesUsedConfig channelCfg = channelConfig.as(BrickletGPSSatellitesUsedConfig.class);
                   updateStateFn.accept(value, transformGPSSatellitesUsedGetter0(this.getStatus(), cfg));
                   return;
               }
            case "GPSAltitude": {
                   BrickletGPSAltitudeConfig channelCfg = channelConfig.as(BrickletGPSAltitudeConfig.class);
                   updateStateFn.accept(value, transformGPSAltitudeGetter0(this.getAltitude(), cfg));
                   return;
               }
            case "GPSGeoidalSeparation": {
                   BrickletGPSGeoidalSeparationConfig channelCfg = channelConfig.as(BrickletGPSGeoidalSeparationConfig.class);
                   updateStateFn.accept(value, transformGPSGeoidalSeparationGetter0(this.getAltitude(), cfg));
                   return;
               }
            case "GPSCourse": {
                   BrickletGPSCourseConfig channelCfg = channelConfig.as(BrickletGPSCourseConfig.class);
                   updateStateFn.accept(value, transformGPSCourseGetter0(this.getMotion(), cfg));
                   return;
               }
            case "GPSSpeed": {
                   BrickletGPSSpeedConfig channelCfg = channelConfig.as(BrickletGPSSpeedConfig.class);
                   updateStateFn.accept(value, transformGPSSpeedGetter0(this.getMotion(), cfg));
                   return;
               }
            case "GPSDateTime": {
                   BrickletGPSDateTimeConfig channelCfg = channelConfig.as(BrickletGPSDateTimeConfig.class);
                   updateStateFn.accept(value, transformGPSDateTimeGetter0(this.getDateTime(), cfg));
                   return;
               }
            case "GPSRestart":
               return;
            default:
                logger.warn("Refresh for unknown channel {}", value);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletGPSConfig cfg = (BrickletGPSConfig) config.as(BrickletGPSConfig.class);
        switch(channel) {
            case "GPSRestart":
                if (command instanceof StringType) {
                    BrickletGPSRestartConfig channelCfg = channelConfig.as(BrickletGPSRestartConfig.class);
                    StringType cmd = (StringType) command;
                    this.restart(Short.valueOf(cmd.toString()));
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformGPSLocationCallback0(long latitude, char ns, long longitude, char ew, int pdop, int hdop, int vdop, int epe, BrickletGPSConfig cfg) {
        return new PointType(new DecimalType(latitude / 1000000.0 * (ns == 'N' ? 1 : -1)), new DecimalType(longitude / 1000000.0 * (ew == 'E' ? 1 : -1)));
    }
	    private org.eclipse.smarthome.core.types.State transformGPSFixCallback0(short fix, short satellitesView, short satellitesUsed, BrickletGPSConfig cfg) {
        return fix > 1 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformGPSSatellitesInViewCallback0(short fix, short satellitesView, short satellitesUsed, BrickletGPSConfig cfg) {
        return new QuantityType(satellitesView, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformGPSSatellitesUsedCallback0(short fix, short satellitesView, short satellitesUsed, BrickletGPSConfig cfg) {
        return new QuantityType(satellitesUsed, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformGPSAltitudeCallback0(int altitude, int geoidalSeparation, BrickletGPSConfig cfg) {
        return new QuantityType(altitude / 100.0, SIUnits.METRE);
    }
	    private org.eclipse.smarthome.core.types.State transformGPSGeoidalSeparationCallback0(int altitude, int geoidalSeparation, BrickletGPSConfig cfg) {
        return new QuantityType(geoidalSeparation / 100.0, SIUnits.METRE);
    }
	    private org.eclipse.smarthome.core.types.State transformGPSCourseCallback0(long course, long speed, BrickletGPSConfig cfg) {
        return new QuantityType(course / 100.0, SmartHomeUnits.DEGREE_ANGLE);
    }
	    private org.eclipse.smarthome.core.types.State transformGPSSpeedCallback0(long course, long speed, BrickletGPSConfig cfg) {
        return new QuantityType(speed / 100.0, SIUnits.KILOMETRE_PER_HOUR);
    }
	    private org.eclipse.smarthome.core.types.State transformGPSDateTimeCallback0(long date, long time, BrickletGPSConfig cfg) {
        return new DateTimeType(Helper.parseGPSDateTime(date, time).withZoneSameInstant(ZoneId.systemDefault()));
    }
	    private org.eclipse.smarthome.core.types.State transformGPSFixGetter0(Status value, BrickletGPSConfig cfg) {
        return value.fix > 1 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformGPSSatellitesInViewGetter0(Status value, BrickletGPSConfig cfg) {
        return new QuantityType(value.satellitesView, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformGPSSatellitesUsedGetter0(Status value, BrickletGPSConfig cfg) {
        return new QuantityType(value.satellitesUsed, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformGPSAltitudeGetter0(Altitude value, BrickletGPSConfig cfg) {
        return new QuantityType(value.altitude / 100.0, SIUnits.METRE);
    }
	    private org.eclipse.smarthome.core.types.State transformGPSGeoidalSeparationGetter0(Altitude value, BrickletGPSConfig cfg) {
        return new QuantityType(value.geoidalSeparation / 100.0, SIUnits.METRE);
    }
	    private org.eclipse.smarthome.core.types.State transformGPSCourseGetter0(Motion value, BrickletGPSConfig cfg) {
        return new QuantityType(value.course / 100.0, SmartHomeUnits.DEGREE_ANGLE);
    }
	    private org.eclipse.smarthome.core.types.State transformGPSSpeedGetter0(Motion value, BrickletGPSConfig cfg) {
        return new QuantityType(value.speed / 100.0, SIUnits.KILOMETRE_PER_HOUR);
    }
	    private org.eclipse.smarthome.core.types.State transformGPSDateTimeGetter0(DateTime value, BrickletGPSConfig cfg) {
        return new DateTimeType(Helper.parseGPSDateTime(value.date, value.time).withZoneSameInstant(ZoneId.systemDefault()));
    }
}
