/* ***********************************************************
 * This file was automatically generated on 2019-09-23.      *
 *                                                           *
 * OpenHAB Bindings Version 2.1.23                           *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;
import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.function.Function;
import java.util.function.BiConsumer;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.thing.CommonTriggerEvents;
import org.eclipse.smarthome.core.library.types.OnOffType;
import org.eclipse.smarthome.core.library.types.StringType;

/**
 * 4 galvanically isolated solid state relays
 */
public class BrickletIndustrialQuadRelay extends Device {
	public final static int DEVICE_IDENTIFIER = 225;
	public final static String DEVICE_DISPLAY_NAME = "Industrial Quad Relay Bricklet";

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(DEVICE_DISPLAY_NAME, "industrialquadrelay", DEVICE_IDENTIFIER, BrickletIndustrialQuadRelay.class);

	public final static byte FUNCTION_SET_VALUE = (byte)1;
	public final static byte FUNCTION_GET_VALUE = (byte)2;
	public final static byte FUNCTION_SET_MONOFLOP = (byte)3;
	public final static byte FUNCTION_GET_MONOFLOP = (byte)4;
	public final static byte FUNCTION_SET_GROUP = (byte)5;
	public final static byte FUNCTION_GET_GROUP = (byte)6;
	public final static byte FUNCTION_GET_AVAILABLE_FOR_GROUP = (byte)7;
	public final static byte FUNCTION_SET_SELECTED_VALUES = (byte)9;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_MONOFLOP_DONE = 8;


	private List<MonoflopDoneListener> listenerMonoflopDone = new CopyOnWriteArrayList<MonoflopDoneListener>();

	public class Monoflop {
		public int value;
		public long time;
		public long timeRemaining;

		public String toString() {
			return "[" + "value = " + value + ", " + "time = " + time + ", " + "timeRemaining = " + timeRemaining + "]";
		}
	}

	/**
	 * This listener is triggered whenever a monoflop timer reaches 0. The
	 * parameters contain the involved pins and the current value of the pins
	 * (the value after the monoflop).
	 */
	public interface MonoflopDoneListener extends DeviceListener {
		public void monoflopDone(int selectionMask, int valueMask);
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletIndustrialQuadRelay(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 0;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_VALUE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_VALUE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_MONOFLOP)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_MONOFLOP)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_GROUP)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_GROUP)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_AVAILABLE_FOR_GROUP)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_SELECTED_VALUES)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_MONOFLOP_DONE] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int selectionMask = IPConnection.unsignedShort(bb.getShort());
				int valueMask = IPConnection.unsignedShort(bb.getShort());

				for (MonoflopDoneListener listener: listenerMonoflopDone) {
					listener.monoflopDone(selectionMask, valueMask);
				}
			}
		};
	}

	/**
	 * Sets the output value with a bitmask (16bit). A 1 in the bitmask means relay
	 * closed and a 0 means relay open.
	 * 
	 * For example: The value 3 or 0b0011 will close the relay of pins 0-1 and open
	 * the other pins.
	 * 
	 * If no groups are used (see {@link BrickletIndustrialQuadRelay#setGroup(char[])}), the pins correspond to the
	 * markings on the Industrial Quad Relay Bricklet.
	 * 
	 * If groups are used, the pins correspond to the element in the group.
	 * Element 1 in the group will get pins 0-3, element 2 pins 4-7, element 3
	 * pins 8-11 and element 4 pins 12-15.
	 * 
	 * All running monoflop timers will be aborted if this function is called.
	 */
	public void setValue(int valueMask) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_VALUE, this);

		bb.putShort((short)valueMask);

		sendRequest(bb.array());
	}

	/**
	 * Returns the bitmask as set by {@link BrickletIndustrialQuadRelay#setValue(int)}.
	 */
	public int getValue() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_VALUE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int valueMask = IPConnection.unsignedShort(bb.getShort());

		return valueMask;
	}

	/**
	 * Configures a monoflop of the pins specified by the first parameter
	 * bitmask.
	 * 
	 * The second parameter is a bitmask with the desired value of the specified
	 * pins. A 1 in the bitmask means relay closed and a 0 means relay open.
	 * 
	 * The third parameter indicates the time (in ms) that the pins should hold
	 * the value.
	 * 
	 * If this function is called with the parameters (9, 1, 1500) or
	 * (0b1001, 0b0001, 1500): Pin 0 will close and pin 3 will open. In 1.5s pin 0
	 * will open and pin 3 will close again.
	 * 
	 * A monoflop can be used as a fail-safe mechanism. For example: Lets assume you
	 * have a RS485 bus and a Quad Relay Bricklet connected to one of the slave
	 * stacks. You can now call this function every second, with a time parameter
	 * of two seconds and pin 0 closed. Pin 0 will be closed all the time. If now
	 * the RS485 connection is lost, then pin 0 will be opened in at most two seconds.
	 */
	public void setMonoflop(int selectionMask, int valueMask, long time) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)16, FUNCTION_SET_MONOFLOP, this);

		bb.putShort((short)selectionMask);
		bb.putShort((short)valueMask);
		bb.putInt((int)time);

		sendRequest(bb.array());
	}

	/**
	 * Returns (for the given pin) the current value and the time as set by
	 * {@link BrickletIndustrialQuadRelay#setMonoflop(int, int, long)} as well as the remaining time until the value flips.
	 * 
	 * If the timer is not running currently, the remaining time will be returned
	 * as 0.
	 */
	public Monoflop getMonoflop(short pin) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_MONOFLOP, this);

		bb.put((byte)pin);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Monoflop obj = new Monoflop();
		obj.value = IPConnection.unsignedShort(bb.getShort());
		obj.time = IPConnection.unsignedInt(bb.getInt());
		obj.timeRemaining = IPConnection.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Sets a group of Quad Relay Bricklets that should work together. You can
	 * find Bricklets that can be grouped together with {@link BrickletIndustrialQuadRelay#getAvailableForGroup()}.
	 * 
	 * The group consists of 4 elements. Element 1 in the group will get pins 0-3,
	 * element 2 pins 4-7, element 3 pins 8-11 and element 4 pins 12-15.
	 * 
	 * Each element can either be one of the ports ('a' to 'd') or 'n' if it should
	 * not be used.
	 * 
	 * For example: If you have two Quad Relay Bricklets connected to port A and
	 * port B respectively, you could call with ``['a', 'b', 'n', 'n']``.
	 * 
	 * Now the pins on the Quad Relay on port A are assigned to 0-3 and the
	 * pins on the Quad Relay on port B are assigned to 4-7. It is now possible
	 * to call {@link BrickletIndustrialQuadRelay#setValue(int)} and control two Bricklets at the same time.
	 */
	public void setGroup(char[] group) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_GROUP, this);

		for (int i = 0; i < 4; i++) {
			bb.put((byte)group[i]);
		}

		sendRequest(bb.array());
	}

	/**
	 * Returns the group as set by {@link BrickletIndustrialQuadRelay#setGroup(char[])}
	 */
	public char[] getGroup() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_GROUP, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		char[] group = new char[4];
		for (int i = 0; i < 4; i++) {
			group[i] = (char)(bb.get());
		}

		return group;
	}

	/**
	 * Returns a bitmask of ports that are available for grouping. For example the
	 * value 5 or 0b0101 means: Port A and port C are connected to Bricklets that
	 * can be grouped together.
	 */
	public short getAvailableForGroup() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_AVAILABLE_FOR_GROUP, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		short available = IPConnection.unsignedByte(bb.get());

		return available;
	}

	/**
	 * Sets the output value with a bitmask, according to the selection mask.
	 * The bitmask is 16 bit long, *true* refers to a closed relay and
	 * *false* refers to an open relay.
	 * 
	 * For example: The values (3, 1) or (0b0011, 0b0001) will close the relay of
	 * pin 0, open the relay of pin 1 and leave the others untouched.
	 * 
	 * If no groups are used (see {@link BrickletIndustrialQuadRelay#setGroup(char[])}), the pins correspond to the
	 * markings on the Industrial Quad Relay Bricklet.
	 * 
	 * If groups are used, the pins correspond to the element in the group.
	 * Element 1 in the group will get pins 0-3, element 2 pins 4-7, element 3
	 * pins 8-11 and element 4 pins 12-15.
	 * 
	 * Running monoflop timers for the selected relays will be aborted if this function
	 * is called.
	 */
	public void setSelectedValues(int selectionMask, int valueMask) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_SELECTED_VALUES, this);

		bb.putShort((short)selectionMask);
		bb.putShort((short)valueMask);

		sendRequest(bb.array());
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c' or 'd'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnection.string(bb, 8);
		obj.connectedUid = IPConnection.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Adds a MonoflopDone listener.
	 */
	public void addMonoflopDoneListener(MonoflopDoneListener listener) {
		listenerMonoflopDone.add(listener);
	}

	/**
	 * Removes a MonoflopDone listener.
	 */
	public void removeMonoflopDoneListener(MonoflopDoneListener listener) {
		listenerMonoflopDone.remove(listener);
	}

    private final Logger logger = LoggerFactory.getLogger(BrickletIndustrialQuadRelay.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletIndustrialQuadRelay.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletIndustrialQuadRelayConfig cfg = (BrickletIndustrialQuadRelayConfig) config.as(BrickletIndustrialQuadRelayConfig.class);
        this.addMonoflopDoneListener((selectionMask, valueMask) -> {if((selectionMask & (1 << 0)) == 1) {updateStateFn.accept("IndustrialQuadRelayRelay0", transformIndustrialQuadRelayRelay0Callback0(selectionMask, valueMask, cfg));}});
		this.addMonoflopDoneListener((selectionMask, valueMask) -> {if((selectionMask & (1 << 1)) == 1) {updateStateFn.accept("IndustrialQuadRelayRelay1", transformIndustrialQuadRelayRelay1Callback0(selectionMask, valueMask, cfg));}});
		this.addMonoflopDoneListener((selectionMask, valueMask) -> {if((selectionMask & (1 << 2)) == 1) {updateStateFn.accept("IndustrialQuadRelayRelay2", transformIndustrialQuadRelayRelay2Callback0(selectionMask, valueMask, cfg));}});
		this.addMonoflopDoneListener((selectionMask, valueMask) -> {if((selectionMask & (1 << 3)) == 1) {updateStateFn.accept("IndustrialQuadRelayRelay3", transformIndustrialQuadRelayRelay3Callback0(selectionMask, valueMask, cfg));}});
        
		{
		BrickletIndustrialQuadRelayRelayConfig channelCfg = getChannelConfigFn.apply("IndustrialQuadRelayRelay0").as(BrickletIndustrialQuadRelayRelayConfig.class);
		
		}
		{
		BrickletIndustrialQuadRelayRelayConfig channelCfg = getChannelConfigFn.apply("IndustrialQuadRelayRelay1").as(BrickletIndustrialQuadRelayRelayConfig.class);
		
		}
		{
		BrickletIndustrialQuadRelayRelayConfig channelCfg = getChannelConfigFn.apply("IndustrialQuadRelayRelay2").as(BrickletIndustrialQuadRelayRelayConfig.class);
		
		}
		{
		BrickletIndustrialQuadRelayRelayConfig channelCfg = getChannelConfigFn.apply("IndustrialQuadRelayRelay3").as(BrickletIndustrialQuadRelayRelayConfig.class);
		
		}
		{
		BrickletIndustrialQuadRelayMonoflopConfig channelCfg = getChannelConfigFn.apply("IndustrialQuadRelayMonofloprelay0").as(BrickletIndustrialQuadRelayMonoflopConfig.class);
		
		}
		{
		BrickletIndustrialQuadRelayMonoflopConfig channelCfg = getChannelConfigFn.apply("IndustrialQuadRelayMonofloprelay1").as(BrickletIndustrialQuadRelayMonoflopConfig.class);
		
		}
		{
		BrickletIndustrialQuadRelayMonoflopConfig channelCfg = getChannelConfigFn.apply("IndustrialQuadRelayMonofloprelay2").as(BrickletIndustrialQuadRelayMonoflopConfig.class);
		
		}
		{
		BrickletIndustrialQuadRelayMonoflopConfig channelCfg = getChannelConfigFn.apply("IndustrialQuadRelayMonofloprelay3").as(BrickletIndustrialQuadRelayMonoflopConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        BrickletIndustrialQuadRelayConfig cfg = (BrickletIndustrialQuadRelayConfig) config.as(BrickletIndustrialQuadRelayConfig.class);
        this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
        
		
		
		
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletIndustrialQuadRelayConfig cfg = (BrickletIndustrialQuadRelayConfig) config.as(BrickletIndustrialQuadRelayConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("IndustrialQuadRelayRelay0");
		result.add("IndustrialQuadRelayRelay1");
		result.add("IndustrialQuadRelayRelay2");
		result.add("IndustrialQuadRelayRelay3");
		result.add("IndustrialQuadRelayMonofloprelay0");
		result.add("IndustrialQuadRelayMonofloprelay1");
		result.add("IndustrialQuadRelayMonofloprelay2");
		result.add("IndustrialQuadRelayMonofloprelay3");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "IndustrialQuadRelayRelay":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "IndustrialQuadRelayRelay"), "NOT USED", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:IndustrialQuadRelayRelay")).withDescription("NOT USED").build();
            case "IndustrialQuadRelayMonoflop":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "IndustrialQuadRelayMonoflop"), "NOT USED", "String").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:IndustrialQuadRelayMonoflop")).withDescription("Triggers a monoflop as configured")
.withCommandDescription(CommandDescriptionBuilder.create().withCommandOption(new CommandOption("TRIGGER", "Trigger")).build()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Industrial Quad Relay Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.getId())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("4 galvanically isolated solid state relays").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("IndustrialQuadRelayRelay0", new ChannelTypeUID("tinkerforge", "IndustrialQuadRelayRelay")).withLabel("Relay 0").withDescription("Switches Relay 0. A running monoflop timer for this relay will be aborted if the relay is toggled by this channel.").build(), new ChannelDefinitionBuilder("IndustrialQuadRelayRelay1", new ChannelTypeUID("tinkerforge", "IndustrialQuadRelayRelay")).withLabel("Relay 1").withDescription("Switches Relay 1. A running monoflop timer for this relay will be aborted if the relay is toggled by this channel.").build(), new ChannelDefinitionBuilder("IndustrialQuadRelayRelay2", new ChannelTypeUID("tinkerforge", "IndustrialQuadRelayRelay")).withLabel("Relay 2").withDescription("Switches Relay 2. A running monoflop timer for this relay will be aborted if the relay is toggled by this channel.").build(), new ChannelDefinitionBuilder("IndustrialQuadRelayRelay3", new ChannelTypeUID("tinkerforge", "IndustrialQuadRelayRelay")).withLabel("Relay 3").withDescription("Switches Relay 3. A running monoflop timer for this relay will be aborted if the relay is toggled by this channel.").build(), new ChannelDefinitionBuilder("IndustrialQuadRelayMonofloprelay0", new ChannelTypeUID("tinkerforge", "IndustrialQuadRelayMonoflop")).withLabel("Monoflop Relay 0").build(), new ChannelDefinitionBuilder("IndustrialQuadRelayMonofloprelay1", new ChannelTypeUID("tinkerforge", "IndustrialQuadRelayMonoflop")).withLabel("Monoflop Relay 1").build(), new ChannelDefinitionBuilder("IndustrialQuadRelayMonofloprelay2", new ChannelTypeUID("tinkerforge", "IndustrialQuadRelayMonoflop")).withLabel("Monoflop Relay 2").build(), new ChannelDefinitionBuilder("IndustrialQuadRelayMonofloprelay3", new ChannelTypeUID("tinkerforge", "IndustrialQuadRelayMonoflop")).withLabel("Monoflop Relay 3").build())).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:industrialquadrelay":
                return new ConfigDescription(uri, Arrays.asList(), Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals")));
            case "channel-type:tinkerforge:IndustrialQuadRelayRelay":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build()));
            case "channel-type:tinkerforge:IndustrialQuadRelayMonoflop":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("monoflopDuration", Type.INTEGER).withDefault("1000").withDescription("The time (in ms) that the relay should hold the configured value.").withLabel("Monoflop Duration").withUnit("ms").withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(2147483647)).build(), ConfigDescriptionParameterBuilder.create("monoflopValue", Type.BOOLEAN).withDefault("true").withDescription("The desired value of the specified channel. Activated means relay closed and Deactivated means relay open.").withLabel("Monoflop Value").build()));
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String value, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletIndustrialQuadRelayConfig cfg = (BrickletIndustrialQuadRelayConfig) config.as(BrickletIndustrialQuadRelayConfig.class);
        switch(value) {
            case "IndustrialQuadRelayRelay0": {
                   BrickletIndustrialQuadRelayRelayConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayRelayConfig.class);
                   updateStateFn.accept(value, transformIndustrialQuadRelayRelay0Getter0(this.getValue(), cfg));
                   return;
               }
            case "IndustrialQuadRelayRelay1": {
                   BrickletIndustrialQuadRelayRelayConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayRelayConfig.class);
                   updateStateFn.accept(value, transformIndustrialQuadRelayRelay1Getter0(this.getValue(), cfg));
                   return;
               }
            case "IndustrialQuadRelayRelay2": {
                   BrickletIndustrialQuadRelayRelayConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayRelayConfig.class);
                   updateStateFn.accept(value, transformIndustrialQuadRelayRelay2Getter0(this.getValue(), cfg));
                   return;
               }
            case "IndustrialQuadRelayRelay3": {
                   BrickletIndustrialQuadRelayRelayConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayRelayConfig.class);
                   updateStateFn.accept(value, transformIndustrialQuadRelayRelay3Getter0(this.getValue(), cfg));
                   return;
               }
            case "IndustrialQuadRelayMonofloprelay0": {
                   BrickletIndustrialQuadRelayMonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayMonoflopConfig.class);
                   updateStateFn.accept(value, transformIndustrialQuadRelayMonofloprelay0Getter0(this.getMonoflop((short) 0), cfg));
                   return;
               }
            case "IndustrialQuadRelayMonofloprelay1": {
                   BrickletIndustrialQuadRelayMonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayMonoflopConfig.class);
                   updateStateFn.accept(value, transformIndustrialQuadRelayMonofloprelay1Getter0(this.getMonoflop((short) 1), cfg));
                   return;
               }
            case "IndustrialQuadRelayMonofloprelay2": {
                   BrickletIndustrialQuadRelayMonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayMonoflopConfig.class);
                   updateStateFn.accept(value, transformIndustrialQuadRelayMonofloprelay2Getter0(this.getMonoflop((short) 2), cfg));
                   return;
               }
            case "IndustrialQuadRelayMonofloprelay3": {
                   BrickletIndustrialQuadRelayMonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayMonoflopConfig.class);
                   updateStateFn.accept(value, transformIndustrialQuadRelayMonofloprelay3Getter0(this.getMonoflop((short) 3), cfg));
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", value);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = new ArrayList<SetterRefresh>();
        BrickletIndustrialQuadRelayConfig cfg = (BrickletIndustrialQuadRelayConfig) config.as(BrickletIndustrialQuadRelayConfig.class);
        switch(channel) {
            case "IndustrialQuadRelayRelay0":
                if (command instanceof OnOffType) {
                    BrickletIndustrialQuadRelayRelayConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayRelayConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setValue(cmd == OnOffType.ON ? (getValue() | (1 << 0)) : (getValue() & ~(1 << 0)));
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IndustrialQuadRelayRelay1":
                if (command instanceof OnOffType) {
                    BrickletIndustrialQuadRelayRelayConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayRelayConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setValue(cmd == OnOffType.ON ? (getValue() | (1 << 1)) : (getValue() & ~(1 << 1)));
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IndustrialQuadRelayRelay2":
                if (command instanceof OnOffType) {
                    BrickletIndustrialQuadRelayRelayConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayRelayConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setValue(cmd == OnOffType.ON ? (getValue() | (1 << 2)) : (getValue() & ~(1 << 2)));
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IndustrialQuadRelayRelay3":
                if (command instanceof OnOffType) {
                    BrickletIndustrialQuadRelayRelayConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayRelayConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setValue(cmd == OnOffType.ON ? (getValue() | (1 << 3)) : (getValue() & ~(1 << 3)));
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IndustrialQuadRelayMonofloprelay0":
                if (command instanceof StringType) {
                    BrickletIndustrialQuadRelayMonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayMonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(1 << 0, channelCfg.monoflopValue.booleanValue() ? (1 << 0) : 0, channelCfg.monoflopDuration);
                    result.add(new SetterRefresh("IndustrialQuadRelayRelay0", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "IndustrialQuadRelayMonofloprelay1":
                if (command instanceof StringType) {
                    BrickletIndustrialQuadRelayMonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayMonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(1 << 1, channelCfg.monoflopValue.booleanValue() ? (1 << 1) : 0, channelCfg.monoflopDuration);
                    result.add(new SetterRefresh("IndustrialQuadRelayRelay1", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "IndustrialQuadRelayMonofloprelay2":
                if (command instanceof StringType) {
                    BrickletIndustrialQuadRelayMonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayMonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(1 << 2, channelCfg.monoflopValue.booleanValue() ? (1 << 2) : 0, channelCfg.monoflopDuration);
                    result.add(new SetterRefresh("IndustrialQuadRelayRelay2", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "IndustrialQuadRelayMonofloprelay3":
                if (command instanceof StringType) {
                    BrickletIndustrialQuadRelayMonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayMonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(1 << 3, channelCfg.monoflopValue.booleanValue() ? (1 << 3) : 0, channelCfg.monoflopDuration);
                    result.add(new SetterRefresh("IndustrialQuadRelayRelay3", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformIndustrialQuadRelayRelay0Callback0(int selectionMask, int valueMask, BrickletIndustrialQuadRelayConfig cfg) {
        return (valueMask & (1 << 0)) == 1 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIndustrialQuadRelayRelay1Callback0(int selectionMask, int valueMask, BrickletIndustrialQuadRelayConfig cfg) {
        return (valueMask & (1 << 1)) == 1 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIndustrialQuadRelayRelay2Callback0(int selectionMask, int valueMask, BrickletIndustrialQuadRelayConfig cfg) {
        return (valueMask & (1 << 2)) == 1 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIndustrialQuadRelayRelay3Callback0(int selectionMask, int valueMask, BrickletIndustrialQuadRelayConfig cfg) {
        return (valueMask & (1 << 3)) == 1 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIndustrialQuadRelayRelay0Getter0(int value, BrickletIndustrialQuadRelayConfig cfg) {
        return (value & (1 << 0)) == 1 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIndustrialQuadRelayRelay1Getter0(int value, BrickletIndustrialQuadRelayConfig cfg) {
        return (value & (1 << 1)) == 1 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIndustrialQuadRelayRelay2Getter0(int value, BrickletIndustrialQuadRelayConfig cfg) {
        return (value & (1 << 2)) == 1 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIndustrialQuadRelayRelay3Getter0(int value, BrickletIndustrialQuadRelayConfig cfg) {
        return (value & (1 << 3)) == 1 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIndustrialQuadRelayMonofloprelay0Getter0(Monoflop value, BrickletIndustrialQuadRelayConfig cfg) {
        return value.value == 1 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIndustrialQuadRelayMonofloprelay1Getter0(Monoflop value, BrickletIndustrialQuadRelayConfig cfg) {
        return value.value == 1 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIndustrialQuadRelayMonofloprelay2Getter0(Monoflop value, BrickletIndustrialQuadRelayConfig cfg) {
        return value.value == 1 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIndustrialQuadRelayMonofloprelay3Getter0(Monoflop value, BrickletIndustrialQuadRelayConfig cfg) {
        return value.value == 1 ? OnOffType.ON : OnOffType.OFF;
    }
}
